﻿namespace EJGrid.Models
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web;
    using EJGrid.Models;
    using System.Data.SqlClient;
    using System.Data;
    using Sample.Models;


    public static class OrderRepository
    {
        public static IList<EditableOrder> GetAllRecords()
        {
            IList<EditableOrder>  orders = (from ord in new DataClasses1DataContext().Orders.Take(200)
                                                                  select new EditableOrder
                                                                  {
                                                                      OrderID = ord.OrderID,
                                                                      OrderDate = ord.OrderDate,
                                                                      CustomerID = ord.CustomerID,
                                                                      EmployeeID = ord.EmployeeID,
                                                                      Freight = ord.Freight,
                                                                      ShipAddress = ord.ShipAddress,
                                                                      ShipCity = ord.ShipCity,
                                                                      ShipName = ord.ShipName,
                                                                      ShipPostalCode = ord.ShipPostalCode,
                                                                      ShipRegion = ord.ShipRegion,
                                                                      ShipCountry = ord.ShipCountry
                                                                  }).ToList();
            foreach (var order in orders)
            {
                if (order.Freight > 30)
                    order.Verified = true;
                else
                    order.Verified = false;
            }
            
            return orders;
        }

        public static void Update(EditableOrder order)
        {
                SqlConnection con = new SqlConnection(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=|DataDirectory|\NORTHWND.mdf;Integrated Security=True");

                SqlCommand cmd = new SqlCommand();
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.CommandText = "[prc_UpdateOrder]";
                cmd.Parameters.Add(new SqlParameter("@employeeid", SqlDbType.Int)).Value = order.EmployeeID;
                cmd.Parameters.Add(new SqlParameter("@shipCity", SqlDbType.VarChar)).Value = order.ShipCity;
                cmd.Parameters.Add(new SqlParameter("@orderId", SqlDbType.Int)).Value = order.OrderID;
                cmd.Parameters.Add(new SqlParameter("@freight", SqlDbType.Int)).Value = order.Freight;
                cmd.Connection = con;
                con.Open();
                cmd.ExecuteNonQuery();
                con.Close();
        }
        public static void Delete(int OrderID)
        {
            
                SqlConnection con = new SqlConnection(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=|DataDirectory|\NORTHWND.mdf;Integrated Security=True");

                SqlCommand cmd = new SqlCommand();
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.CommandText = "[prc_DeleteOrder]";
                cmd.Parameters.Add(new SqlParameter("@orderId", SqlDbType.Int)).Value = OrderID;
                cmd.Connection = con;
                con.Open();
                cmd.ExecuteNonQuery();
                con.Close();
        }
        public static void Add(EditableOrder order)
        {
                SqlConnection con = new SqlConnection(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=|DataDirectory|\NORTHWND.mdf;Integrated Security=True");

                SqlCommand cmd = new SqlCommand();
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.CommandText = "[prc_InsertOrder]";
                cmd.Parameters.Add(new SqlParameter("@employeeid", SqlDbType.Int)).Value = order.EmployeeID;
                cmd.Parameters.Add(new SqlParameter("@orderId", SqlDbType.Int)).Value = order.OrderID;
                cmd.Parameters.Add(new SqlParameter("@shipCity", SqlDbType.VarChar)).Value = order.ShipCity;
                cmd.Parameters.Add(new SqlParameter("@freight", SqlDbType.Int)).Value = order.Freight;
                cmd.Connection = con;
                con.Open();

                cmd.ExecuteNonQuery();
                con.Close();
        }
    }
}
